#include <stdio.h>
#include <math.h>
#include <stdlib.h> // for rand, system
#include <complex.h>

//////////////////////////////////////////////////////////////////
//				Mandelbrot set generator (educational):  		//
//////////////////////////////////////////////////////////////////
// Free to use, improve, and redistribute. No commercial use.   //
// Created by Niels Benedikter. Please keep this document head. //
// Feel free to add your name if you make modifications.		//
//////////////////////////////////////////////////////////////////


int main (void)
{
	printf("Mandelbrot set generator.\n");

	// prepare the file to collect the output
 	FILE* file1 = fopen("mandelbrot.dat", "wt");
    if (file1 == NULL)  {
        printf("Problem: File infetatti.dat could not be created!\n");
       	return(1);
    }
    
    double complex z = 0;
    double complex c = 0;

    // physical constants
    int NMAX = 105;

    for (double x = -1.5; x < 0.5; x+=0.001) {
    for (double y = -1.2; y < 1.2; y+=0.001) {

    z = 0;                  // Mandelbrot iteration starts at the origin
    c = x + y * I;

	    for (int i =0; i < NMAX; i++) {
            z = z*z + c;        // Mandelbrot iteration
		    }
        
        if (cabs(z) < 3)   {        // did the iteration "converge" after NMAX steps? If yes, mark the point c.
            fprintf(file1,"%lf %lf\n",x,y);
        }        

    }
    }

	fclose(file1);

//	char d;
//	printf("Run gnuplot to show simulation? (y=yes,other=no)");
//	scanf("%c",&d);
//	if (d=='y') {
		system("gnuplot -p 'script.gp'");
//	}

	return 0;
}
